#include <Tle493d_a2b6.h>
Tle493d_a2b6 Tle493dMagnetic3DSensor = Tle493d_a2b6(Tle493d::FASTMODE,Tle493d::TLE493D_A0);

#define XPOS 2
#define XNEG 3
#define YPOS 4
#define YNEG 5
#define ZPOS 6
#define ZNEG 7
#define LED 11

int T = 30000; // number of micro seconds delay (minimum is 5000)'

int xstep = 0;
int ystep = 0;
int zstep = 0;

int XPIN;
int YPIN;
int ZPIN;

long max3(long a, long b, long c){
   long maxguess;
   maxguess = max(a,b);
   maxguess = max(maxguess,c);
   return(maxguess);
}

void setup() {
  Serial.begin(9600); // opens serial port, sets data rate to 9600 bps
  while(!Serial);

  pinMode(XPOS,OUTPUT);
  pinMode(XNEG,OUTPUT);
  pinMode(YPOS,OUTPUT);
  pinMode(YNEG,OUTPUT);
  pinMode(ZPOS,OUTPUT);
  pinMode(ZNEG,OUTPUT);
  digitalWriteFast(XPOS,LOW);
  digitalWriteFast(XNEG,LOW);
  digitalWriteFast(YPOS,LOW);
  digitalWriteFast(YNEG,LOW);
  digitalWriteFast(ZPOS,LOW);
  digitalWriteFast(ZNEG,LOW);

  Tle493dMagnetic3DSensor.begin();
  Tle493dMagnetic3DSensor.enableTemp();

  pinMode(LED,OUTPUT);
  digitalWriteFast(LED,LOW);
}

void loop() {  
  if (Serial.available() > 0) {
    digitalWriteFast(LED,HIGH);
    xstep = Serial.parseInt();
    ystep = Serial.parseInt();
    zstep = Serial.parseInt();
    XPIN = XPOS;
    YPIN = YPOS;
    ZPIN = ZPOS;
    if(xstep<0){
      XPIN = XNEG;
      xstep = -xstep;
    }
    if(ystep<0){
      YPIN = YNEG;
      ystep = -ystep;
    }
    if(zstep<0){
      ZPIN = ZNEG;
      zstep = -zstep;
    }
    long maxcnt = max3(xstep,ystep,zstep);
    for (uint32_t cnt = 0; cnt < maxcnt; ++cnt) {
      if(cnt<xstep)
        digitalWriteFast(XPIN,HIGH);
      if(cnt<ystep)
        digitalWriteFast(YPIN,HIGH);
      if(cnt<zstep)
        digitalWriteFast(ZPIN,HIGH);
      delayMicroseconds(T/2);
      digitalWriteFast(XPOS,LOW);
      digitalWriteFast(XNEG,LOW);
      digitalWriteFast(YPOS,LOW);
      digitalWriteFast(YNEG,LOW);
      digitalWriteFast(ZPOS,LOW);
      digitalWriteFast(ZNEG,LOW);
      delayMicroseconds(T/2);
    }
    delayMicroseconds(2*T);
      
    Tle493dMagnetic3DSensor.updateData();
    Serial.print(Tle493dMagnetic3DSensor.getX());
    Serial.print(",");
    Serial.print(Tle493dMagnetic3DSensor.getY());
    Serial.print(",");
    Serial.println(Tle493dMagnetic3DSensor.getZ());
    digitalWriteFast(LED,LOW);
  }
}
